import re
import random

def veze(path):
  blocks = input(path)
  blocks.select_block((1,3))

def input(path):
  inf = open(path, 'r')
  lines = inf.readlines()
  blocks = Blocks(lines[0])
  for i in range(1, len(lines)):
    blocks.insertBlocks(lines[i])
  return blocks 

class Block:
  def __init__(self, size, color):
    self.size = size 
  
class Blocks:
  def __init__(self, spec):
    reg = re.compile("(\d+)\s+(\d+)\s+(\w)")
    spec = reg.match(spec).group(1,2,3)
    self.size = int(spec[0]), int(spec[1])
    self.type = spec[2]
    self.full = True if self.type[0]=="P" or self.type[0]=="p" else False
    self.diff_color = True if len(self.type)>1 and (self.type[1]=="B" or self.type[1]=="b") else False
    self.colors = dict(zip(["A","R","G","B","Y"],list(range(5))))
    self._colors = dict(zip(list(range(5)),["A","R","G","B","Y"]))
    #size(0,1) colors - number of blocks
    self.blocks = []
    self.re = re.compile("(\w)\s+(\d+)(x|X)(\d+)\s+(\d+)")
    
  def find_block(self, size, create = False):
    for b in self.blocks:
      if b[0] == size[0] and b[1] == size[1]:
        return b
    else:
      if create:
        b = [size, [0 for x in range(len(self.colors))]]
        if min(size) == 0:
          return b
        self.blocks.append(b)
        return b
      else:
        return None
        
  def insertBlocks(self, line):
    values = self.re.match(line).group(*list(range(1,6)))
    if values[1] < values[3]:
      values = [values[0], int(values[3]), values[2], int(values[1]), int(values[4])]
    else:
      values = [values[0], int(values[1]), values[2], int(values[3]), int(values[4])]
    b = self.find_block((values[1], values[3]), True)
    b[1][self.colors[values[0]]]+=values[4]
    
  def select_block(self, size, not_colors = []):
    for b in self.blocks:
      if b[0] == size:
        return Block(size, self.substract_random_color(b, not_colors))
      elif b[0] == (size[1], size[0]):
        return Block((size[0], size[1]), self.substract_random_color(b, not_colors))
    return None
  
  def substract_random_color(self, block, not_colors = []):
    sum = 0
    for i in range(5):
      if self._colors[i] not in not_colors:
        sum+=block[1][i]
    r = random.randint(0,sum-1)
    for i in range(5):
      if self._colors[i] not in not_colors:
        r-=block[1][i]
        if r<0:
          block[1][i]-=1
          return self._colors[i]
    
if __name__ == "__main__":
  veze("specifikace-10.in")      